//
//  EmojiMemoryGame.swift
//  Memorize
//
//  Created by Sameh Fakhouri on 9/8/21.
//

import SwiftUI


class EmojiMemoryGame: ObservableObject {
    
    typealias Card = MemoryGame<String>.Card

    private static let emojis: [String] = ["🚖", "🚗", "🚘", "🚙", "🚚", "🚛", "🚜", "🚠", "🚤", "🚲", "🏍", "🏎", "🛥", "✈️", "⛵️", "🚀", "🚑", "🚌", "🛴", "🚒", "🛺", "🚅", "🚢", "🚉"]
    
    private static func createMemeoryGame() -> MemoryGame<String> {
        MemoryGame<String>(numberOfPairsOfCards: 4) { pairIndex in
            EmojiMemoryGame.emojis[pairIndex]
        }
    }
       
    @Published private var model = createMemeoryGame()
    
    var cards: Array<Card> {
        return model.cards
    }
    
    
    // MARK: - Intent(s)
    
    func choose(_ card: Card) {
        model.choose(card)
    }
    
}
